/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CHOPPER_H
#define CHOPPER_H

#include <iostream>
#include "SDL.h"
#include "sprite.h"
//#include "llist.h"
#include "trooper.h"

const int GUN_BEGIN = 350;
const int GUN_END = 450;
const int TROOPER_VALUE = 500;
const int WIDTH = 800;
const int NUM_OF_CHOP = 3;

class chopperl: public sprite
{
  private:
    int points;
    bool end;

  public:
    chopperl(int x);
    int getPoints() { return points; }
    void move(bool plane);
    bool getEnd() {return end;};
    void hit() {end = true;};
    bool drop_trooper() 
    {
      if ((dst.x < (GUN_BEGIN-38) || dst.x > GUN_END) && dst.x > 0 && dst.x < (WIDTH-38))
      {
	int random = (rand()%TROOPER_VALUE)+1;
	//std::cout << std::endl << random << std::endl;
	return (random == 1);
	//return (((rand()%100)+1) == 1);
      }
      else
      	return false;
    }
};

class chopperr: public sprite
{
  private:
    int points;
    bool end;
    
  public:
    chopperr(int x);
    int getPoints() { return points; }
    void move(bool plane);
    bool getEnd() {return end;};
    void hit() {end = true;};
    bool drop_trooper() 
    {
      if ((dst.x < (GUN_BEGIN-38) || dst.x > GUN_END) && dst.x > 0 && dst.x < (WIDTH-38))
      {
	int random = (rand()%TROOPER_VALUE)+1;
	//std::cout << std::endl << random << std::endl;
	return (random == 1);
	//return (((rand()%100)+1) == 1);
      }
      else
      	return false;
    }
};

#endif
